#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_dJIK1x64x64TN1x16x4_aX_b0
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=1, NB=64, KB=64, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=16, ku=4, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const double *stM = A + (lda);
   const double *stN = B + (((ldb) << 6));
   const double *pfA = A + M;
   const double BetaAlpha = beta / alpha;
   #define incAk 4
   const int incAm = ((lda) - 64), incAn = -(lda);
   #define incBk 4
   const int incBm = -64, incBn = (((ldb) << 4));
   #define incCm 1
   const int incCn = (((ldc) << 4)) - 1;
   double *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc), *pC4=pC3+(ldc), *pC5=pC4+(ldc), *pC6=pC5+(ldc), *pC7=pC6+(ldc), *pC8=pC7+(ldc), *pC9=pC8+(ldc), *pC10=pC9+(ldc), *pC11=pC10+(ldc), *pC12=pC11+(ldc), *pC13=pC12+(ldc), *pC14=pC13+(ldc), *pC15=pC14+(ldc);
   const double *pA0=A;
   const double *pB0=B, *pB1=pB0+(ldb), *pB2=pB1+(ldb), *pB3=pB2+(ldb), *pB4=pB3+(ldb), *pB5=pB4+(ldb), *pB6=pB5+(ldb), *pB7=pB6+(ldb), *pB8=pB7+(ldb), *pB9=pB8+(ldb), *pB10=pB9+(ldb), *pB11=pB10+(ldb), *pB12=pB11+(ldb), *pB13=pB12+(ldb), *pB14=pB13+(ldb), *pB15=pB14+(ldb);
   register int k;
   register double rA0;
   register double rB0, rB1, rB2, rB3, rB4, rB5, rB6, rB7, rB8, rB9, rB10, rB11, rB12, rB13, rB14, rB15;
   register double rC0_0, rC0_1, rC0_2, rC0_3, rC0_4, rC0_5, rC0_6, rC0_7, rC0_8, rC0_9, rC0_10, rC0_11, rC0_12, rC0_13, rC0_14, rC0_15;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+8);
      ATL_pfl1R(pfA+16);
      ATL_pfl1R(pfA+24);
      ATL_pfl1R(pfA+32);
      ATL_pfl1R(pfA+40);
      ATL_pfl1R(pfA+48);
      ATL_pfl1R(pfA+56);
      pfA += lda;
      rC0_0 = rC0_1 = rC0_2 = rC0_3 = rC0_4 = rC0_5 = rC0_6 = rC0_7 = rC0_8 = rC0_9 = rC0_10 = rC0_11 = rC0_12 = rC0_13 = rC0_14 = rC0_15 = 0.0;
      for (k=64; k; k -= 4) /* easy loop to unroll */
      {
         rA0 = *pA0;
         rB0 = *pB0;
         rB1 = *pB1;
         rB2 = *pB2;
         rB3 = *pB3;
         rB4 = *pB4;
         rB5 = *pB5;
         rB6 = *pB6;
         rC0_0 += rA0 * rB0;
         rB7 = *pB7;
         rB8 = *pB8;
         rB9 = *pB9;
         rB10 = *pB10;
         rB11 = *pB11;
         rB12 = *pB12;
         rB13 = *pB13;
         rC0_1 += rA0 * rB1;
         rB14 = *pB14;
         rB15 = *pB15;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         rC0_8 += rA0 * rB8;
         rC0_9 += rA0 * rB9;
         rC0_10 += rA0 * rB10;
         rC0_11 += rA0 * rB11;
         rC0_12 += rA0 * rB12;
         rC0_13 += rA0 * rB13;
         rC0_14 += rA0 * rB14;
         rC0_15 += rA0 * rB15;
         rA0 = pA0[1];
         rB0 = pB0[1];
         rB1 = pB1[1];
         rB2 = pB2[1];
         rB3 = pB3[1];
         rB4 = pB4[1];
         rB5 = pB5[1];
         rB6 = pB6[1];
         rC0_0 += rA0 * rB0;
         rB7 = pB7[1];
         rB8 = pB8[1];
         rB9 = pB9[1];
         rB10 = pB10[1];
         rB11 = pB11[1];
         rB12 = pB12[1];
         rB13 = pB13[1];
         rC0_1 += rA0 * rB1;
         rB14 = pB14[1];
         rB15 = pB15[1];
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         rC0_8 += rA0 * rB8;
         rC0_9 += rA0 * rB9;
         rC0_10 += rA0 * rB10;
         rC0_11 += rA0 * rB11;
         rC0_12 += rA0 * rB12;
         rC0_13 += rA0 * rB13;
         rC0_14 += rA0 * rB14;
         rC0_15 += rA0 * rB15;
         rA0 = pA0[2];
         rB0 = pB0[2];
         rB1 = pB1[2];
         rB2 = pB2[2];
         rB3 = pB3[2];
         rB4 = pB4[2];
         rB5 = pB5[2];
         rB6 = pB6[2];
         rC0_0 += rA0 * rB0;
         rB7 = pB7[2];
         rB8 = pB8[2];
         rB9 = pB9[2];
         rB10 = pB10[2];
         rB11 = pB11[2];
         rB12 = pB12[2];
         rB13 = pB13[2];
         rC0_1 += rA0 * rB1;
         rB14 = pB14[2];
         rB15 = pB15[2];
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         rC0_8 += rA0 * rB8;
         rC0_9 += rA0 * rB9;
         rC0_10 += rA0 * rB10;
         rC0_11 += rA0 * rB11;
         rC0_12 += rA0 * rB12;
         rC0_13 += rA0 * rB13;
         rC0_14 += rA0 * rB14;
         rC0_15 += rA0 * rB15;
         rA0 = pA0[3];
         rB0 = pB0[3];
         rB1 = pB1[3];
         rB2 = pB2[3];
         rB3 = pB3[3];
         rB4 = pB4[3];
         rB5 = pB5[3];
         rB6 = pB6[3];
         rC0_0 += rA0 * rB0;
         rB7 = pB7[3];
         rB8 = pB8[3];
         rB9 = pB9[3];
         rB10 = pB10[3];
         rB11 = pB11[3];
         rB12 = pB12[3];
         rB13 = pB13[3];
         rC0_1 += rA0 * rB1;
         rB14 = pB14[3];
         rB15 = pB15[3];
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         rC0_8 += rA0 * rB8;
         rC0_9 += rA0 * rB9;
         rC0_10 += rA0 * rB10;
         rC0_11 += rA0 * rB11;
         rC0_12 += rA0 * rB12;
         rC0_13 += rA0 * rB13;
         rC0_14 += rA0 * rB14;
         rC0_15 += rA0 * rB15;
         pA0 += incAk;
         pB0 += incBk;
         pB1 += incBk;
         pB2 += incBk;
         pB3 += incBk;
         pB4 += incBk;
         pB5 += incBk;
         pB6 += incBk;
         pB7 += incBk;
         pB8 += incBk;
         pB9 += incBk;
         pB10 += incBk;
         pB11 += incBk;
         pB12 += incBk;
         pB13 += incBk;
         pB14 += incBk;
         pB15 += incBk;
      }
      rB0 = alpha;
      rC0_0 *= rB0;
      rC0_1 *= rB0;
      rC0_2 *= rB0;
      rC0_3 *= rB0;
      rC0_4 *= rB0;
      rC0_5 *= rB0;
      rC0_6 *= rB0;
      rC0_7 *= rB0;
      rC0_8 *= rB0;
      rC0_9 *= rB0;
      rC0_10 *= rB0;
      rC0_11 *= rB0;
      rC0_12 *= rB0;
      rC0_13 *= rB0;
      rC0_14 *= rB0;
      rC0_15 *= rB0;
      *pC0 = rC0_0;
      *pC1 = rC0_1;
      *pC2 = rC0_2;
      *pC3 = rC0_3;
      *pC4 = rC0_4;
      *pC5 = rC0_5;
      *pC6 = rC0_6;
      *pC7 = rC0_7;
      *pC8 = rC0_8;
      *pC9 = rC0_9;
      *pC10 = rC0_10;
      *pC11 = rC0_11;
      *pC12 = rC0_12;
      *pC13 = rC0_13;
      *pC14 = rC0_14;
      *pC15 = rC0_15;
      pC0 += incCm;
      pC1 += incCm;
      pC2 += incCm;
      pC3 += incCm;
      pC4 += incCm;
      pC5 += incCm;
      pC6 += incCm;
      pC7 += incCm;
      pC8 += incCm;
      pC9 += incCm;
      pC10 += incCm;
      pC11 += incCm;
      pC12 += incCm;
      pC13 += incCm;
      pC14 += incCm;
      pC15 += incCm;
      pA0 += incAm;
      pB0 += incBm;
      pB1 += incBm;
      pB2 += incBm;
      pB3 += incBm;
      pB4 += incBm;
      pB5 += incBm;
      pB6 += incBm;
      pB7 += incBm;
      pB8 += incBm;
      pB9 += incBm;
      pB10 += incBm;
      pB11 += incBm;
      pB12 += incBm;
      pB13 += incBm;
      pB14 += incBm;
      pB15 += incBm;
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pC4 += incCn;
      pC5 += incCn;
      pC6 += incCn;
      pC7 += incCn;
      pC8 += incCn;
      pC9 += incCn;
      pC10 += incCn;
      pC11 += incCn;
      pC12 += incCn;
      pC13 += incCn;
      pC14 += incCn;
      pC15 += incCn;
      pA0 += incAn;
      pB0 += incBn;
      pB1 += incBn;
      pB2 += incBn;
      pB3 += incBn;
      pB4 += incBn;
      pB5 += incBn;
      pB6 += incBn;
      pB7 += incBn;
      pB8 += incBn;
      pB9 += incBn;
      pB10 += incBn;
      pB11 += incBn;
      pB12 += incBn;
      pB13 += incBn;
      pB14 += incBn;
      pB15 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_dJIK64x64x64TN0x0x0_aX_b0
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=64, NB=64, KB=64, 
 * lda=0, ldb=0, ldc=0, mu=7, nu=16, ku=4, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + (63*(lda));
   const double *stN = B + (((ldb) << 6));
   const double *pfA = A + M;
   const double BetaAlpha = beta / alpha;
   #define incAk 4
   const int incAm = ((7*(lda)) - 64), incAn = -(63*(lda));
   #define incBk 4
   const int incBm = -64, incBn = (((ldb) << 4));
   #define incCm 7
   const int incCn = (((ldc) << 4)) - 63;
   double *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc), *pC4=pC3+(ldc), *pC5=pC4+(ldc), *pC6=pC5+(ldc), *pC7=pC6+(ldc), *pC8=pC7+(ldc), *pC9=pC8+(ldc), *pC10=pC9+(ldc), *pC11=pC10+(ldc), *pC12=pC11+(ldc), *pC13=pC12+(ldc), *pC14=pC13+(ldc), *pC15=pC14+(ldc);
   const double *pA0=A, *pA1=pA0+(lda), *pA2=pA1+(lda), *pA3=pA2+(lda), *pA4=pA3+(lda), *pA5=pA4+(lda), *pA6=pA5+(lda);
   const double *pB0=B, *pB1=pB0+(ldb), *pB2=pB1+(ldb), *pB3=pB2+(ldb), *pB4=pB3+(ldb), *pB5=pB4+(ldb), *pB6=pB5+(ldb), *pB7=pB6+(ldb), *pB8=pB7+(ldb), *pB9=pB8+(ldb), *pB10=pB9+(ldb), *pB11=pB10+(ldb), *pB12=pB11+(ldb), *pB13=pB12+(ldb), *pB14=pB13+(ldb), *pB15=pB14+(ldb);
   register int k;
   register double rA0, rA1, rA2, rA3, rA4, rA5, rA6;
   register double rB0, rB1, rB2, rB3, rB4, rB5, rB6, rB7, rB8, rB9, rB10, rB11, rB12, rB13, rB14, rB15;
   register double rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0, rC6_0, rC0_1, rC1_1, rC2_1, rC3_1, rC4_1, rC5_1, rC6_1, rC0_2, rC1_2, rC2_2, rC3_2, rC4_2, rC5_2, rC6_2, rC0_3, rC1_3, rC2_3, rC3_3, rC4_3, rC5_3, rC6_3, rC0_4, rC1_4, rC2_4, rC3_4, rC4_4, rC5_4, rC6_4, rC0_5, rC1_5, rC2_5, rC3_5, rC4_5, rC5_5, rC6_5, rC0_6, rC1_6, rC2_6, rC3_6, rC4_6, rC5_6, rC6_6, rC0_7, rC1_7, rC2_7, rC3_7, rC4_7, rC5_7, rC6_7, rC0_8, rC1_8, rC2_8, rC3_8, rC4_8, rC5_8, rC6_8, rC0_9, rC1_9, rC2_9, rC3_9, rC4_9, rC5_9, rC6_9, rC0_10, rC1_10, rC2_10, rC3_10, rC4_10, rC5_10, rC6_10, rC0_11, rC1_11, rC2_11, rC3_11, rC4_11, rC5_11, rC6_11, rC0_12, rC1_12, rC2_12, rC3_12, rC4_12, rC5_12, rC6_12, rC0_13, rC1_13, rC2_13, rC3_13, rC4_13, rC5_13, rC6_13, rC0_14, rC1_14, rC2_14, rC3_14, rC4_14, rC5_14, rC6_14, rC0_15, rC1_15, rC2_15, rC3_15, rC4_15, rC5_15, rC6_15;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+8);
      ATL_pfl1R(pfA+16);
      ATL_pfl1R(pfA+24);
      ATL_pfl1R(pfA+32);
      ATL_pfl1R(pfA+40);
      ATL_pfl1R(pfA+48);
      ATL_pfl1R(pfA+56);
      pfA += lda;
      do /* M-loop */
      {
         rC0_0 = rC1_0 = rC2_0 = rC3_0 = rC4_0 = rC5_0 = rC6_0 = rC0_1 = rC1_1 = rC2_1 = rC3_1 = rC4_1 = rC5_1 = rC6_1 = rC0_2 = rC1_2 = rC2_2 = rC3_2 = rC4_2 = rC5_2 = rC6_2 = rC0_3 = rC1_3 = rC2_3 = rC3_3 = rC4_3 = rC5_3 = rC6_3 = rC0_4 = rC1_4 = rC2_4 = rC3_4 = rC4_4 = rC5_4 = rC6_4 = rC0_5 = rC1_5 = rC2_5 = rC3_5 = rC4_5 = rC5_5 = rC6_5 = rC0_6 = rC1_6 = rC2_6 = rC3_6 = rC4_6 = rC5_6 = rC6_6 = rC0_7 = rC1_7 = rC2_7 = rC3_7 = rC4_7 = rC5_7 = rC6_7 = rC0_8 = rC1_8 = rC2_8 = rC3_8 = rC4_8 = rC5_8 = rC6_8 = rC0_9 = rC1_9 = rC2_9 = rC3_9 = rC4_9 = rC5_9 = rC6_9 = rC0_10 = rC1_10 = rC2_10 = rC3_10 = rC4_10 = rC5_10 = rC6_10 = rC0_11 = rC1_11 = rC2_11 = rC3_11 = rC4_11 = rC5_11 = rC6_11 = rC0_12 = rC1_12 = rC2_12 = rC3_12 = rC4_12 = rC5_12 = rC6_12 = rC0_13 = rC1_13 = rC2_13 = rC3_13 = rC4_13 = rC5_13 = rC6_13 = rC0_14 = rC1_14 = rC2_14 = rC3_14 = rC4_14 = rC5_14 = rC6_14 = rC0_15 = rC1_15 = rC2_15 = rC3_15 = rC4_15 = rC5_15 = rC6_15 = 0.0;
         for (k=64; k; k -= 4) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = *pA1;
            rA2 = *pA2;
            rA3 = *pA3;
            rA4 = *pA4;
            rA5 = *pA5;
            rA6 = *pA6;
            rC0_0 += rA0 * rB0;
            rB1 = *pB1;
            rB2 = *pB2;
            rB3 = *pB3;
            rB4 = *pB4;
            rB5 = *pB5;
            rB6 = *pB6;
            rB7 = *pB7;
            rC1_0 += rA1 * rB0;
            rB8 = *pB8;
            rB9 = *pB9;
            rB10 = *pB10;
            rB11 = *pB11;
            rB12 = *pB12;
            rB13 = *pB13;
            rB14 = *pB14;
            rC2_0 += rA2 * rB0;
            rB15 = *pB15;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rC6_0 += rA6 * rB0;
            rC0_1 += rA0 * rB1;
            rC1_1 += rA1 * rB1;
            rC2_1 += rA2 * rB1;
            rC3_1 += rA3 * rB1;
            rC4_1 += rA4 * rB1;
            rC5_1 += rA5 * rB1;
            rC6_1 += rA6 * rB1;
            rC0_2 += rA0 * rB2;
            rC1_2 += rA1 * rB2;
            rC2_2 += rA2 * rB2;
            rC3_2 += rA3 * rB2;
            rC4_2 += rA4 * rB2;
            rC5_2 += rA5 * rB2;
            rC6_2 += rA6 * rB2;
            rC0_3 += rA0 * rB3;
            rC1_3 += rA1 * rB3;
            rC2_3 += rA2 * rB3;
            rC3_3 += rA3 * rB3;
            rC4_3 += rA4 * rB3;
            rC5_3 += rA5 * rB3;
            rC6_3 += rA6 * rB3;
            rC0_4 += rA0 * rB4;
            rC1_4 += rA1 * rB4;
            rC2_4 += rA2 * rB4;
            rC3_4 += rA3 * rB4;
            rC4_4 += rA4 * rB4;
            rC5_4 += rA5 * rB4;
            rC6_4 += rA6 * rB4;
            rC0_5 += rA0 * rB5;
            rC1_5 += rA1 * rB5;
            rC2_5 += rA2 * rB5;
            rC3_5 += rA3 * rB5;
            rC4_5 += rA4 * rB5;
            rC5_5 += rA5 * rB5;
            rC6_5 += rA6 * rB5;
            rC0_6 += rA0 * rB6;
            rC1_6 += rA1 * rB6;
            rC2_6 += rA2 * rB6;
            rC3_6 += rA3 * rB6;
            rC4_6 += rA4 * rB6;
            rC5_6 += rA5 * rB6;
            rC6_6 += rA6 * rB6;
            rC0_7 += rA0 * rB7;
            rC1_7 += rA1 * rB7;
            rC2_7 += rA2 * rB7;
            rC3_7 += rA3 * rB7;
            rC4_7 += rA4 * rB7;
            rC5_7 += rA5 * rB7;
            rC6_7 += rA6 * rB7;
            rC0_8 += rA0 * rB8;
            rC1_8 += rA1 * rB8;
            rC2_8 += rA2 * rB8;
            rC3_8 += rA3 * rB8;
            rC4_8 += rA4 * rB8;
            rC5_8 += rA5 * rB8;
            rC6_8 += rA6 * rB8;
            rC0_9 += rA0 * rB9;
            rC1_9 += rA1 * rB9;
            rC2_9 += rA2 * rB9;
            rC3_9 += rA3 * rB9;
            rC4_9 += rA4 * rB9;
            rC5_9 += rA5 * rB9;
            rC6_9 += rA6 * rB9;
            rC0_10 += rA0 * rB10;
            rC1_10 += rA1 * rB10;
            rC2_10 += rA2 * rB10;
            rC3_10 += rA3 * rB10;
            rC4_10 += rA4 * rB10;
            rC5_10 += rA5 * rB10;
            rC6_10 += rA6 * rB10;
            rC0_11 += rA0 * rB11;
            rC1_11 += rA1 * rB11;
            rC2_11 += rA2 * rB11;
            rC3_11 += rA3 * rB11;
            rC4_11 += rA4 * rB11;
            rC5_11 += rA5 * rB11;
            rC6_11 += rA6 * rB11;
            rC0_12 += rA0 * rB12;
            rC1_12 += rA1 * rB12;
            rC2_12 += rA2 * rB12;
            rC3_12 += rA3 * rB12;
            rC4_12 += rA4 * rB12;
            rC5_12 += rA5 * rB12;
            rC6_12 += rA6 * rB12;
            rC0_13 += rA0 * rB13;
            rC1_13 += rA1 * rB13;
            rC2_13 += rA2 * rB13;
            rC3_13 += rA3 * rB13;
            rC4_13 += rA4 * rB13;
            rC5_13 += rA5 * rB13;
            rC6_13 += rA6 * rB13;
            rC0_14 += rA0 * rB14;
            rC1_14 += rA1 * rB14;
            rC2_14 += rA2 * rB14;
            rC3_14 += rA3 * rB14;
            rC4_14 += rA4 * rB14;
            rC5_14 += rA5 * rB14;
            rC6_14 += rA6 * rB14;
            rC0_15 += rA0 * rB15;
            rC1_15 += rA1 * rB15;
            rC2_15 += rA2 * rB15;
            rC3_15 += rA3 * rB15;
            rC4_15 += rA4 * rB15;
            rC5_15 += rA5 * rB15;
            rC6_15 += rA6 * rB15;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rA1 = pA1[1];
            rA2 = pA2[1];
            rA3 = pA3[1];
            rA4 = pA4[1];
            rA5 = pA5[1];
            rA6 = pA6[1];
            rC0_0 += rA0 * rB0;
            rB1 = pB1[1];
            rB2 = pB2[1];
            rB3 = pB3[1];
            rB4 = pB4[1];
            rB5 = pB5[1];
            rB6 = pB6[1];
            rB7 = pB7[1];
            rC1_0 += rA1 * rB0;
            rB8 = pB8[1];
            rB9 = pB9[1];
            rB10 = pB10[1];
            rB11 = pB11[1];
            rB12 = pB12[1];
            rB13 = pB13[1];
            rB14 = pB14[1];
            rC2_0 += rA2 * rB0;
            rB15 = pB15[1];
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rC6_0 += rA6 * rB0;
            rC0_1 += rA0 * rB1;
            rC1_1 += rA1 * rB1;
            rC2_1 += rA2 * rB1;
            rC3_1 += rA3 * rB1;
            rC4_1 += rA4 * rB1;
            rC5_1 += rA5 * rB1;
            rC6_1 += rA6 * rB1;
            rC0_2 += rA0 * rB2;
            rC1_2 += rA1 * rB2;
            rC2_2 += rA2 * rB2;
            rC3_2 += rA3 * rB2;
            rC4_2 += rA4 * rB2;
            rC5_2 += rA5 * rB2;
            rC6_2 += rA6 * rB2;
            rC0_3 += rA0 * rB3;
            rC1_3 += rA1 * rB3;
            rC2_3 += rA2 * rB3;
            rC3_3 += rA3 * rB3;
            rC4_3 += rA4 * rB3;
            rC5_3 += rA5 * rB3;
            rC6_3 += rA6 * rB3;
            rC0_4 += rA0 * rB4;
            rC1_4 += rA1 * rB4;
            rC2_4 += rA2 * rB4;
            rC3_4 += rA3 * rB4;
            rC4_4 += rA4 * rB4;
            rC5_4 += rA5 * rB4;
            rC6_4 += rA6 * rB4;
            rC0_5 += rA0 * rB5;
            rC1_5 += rA1 * rB5;
            rC2_5 += rA2 * rB5;
            rC3_5 += rA3 * rB5;
            rC4_5 += rA4 * rB5;
            rC5_5 += rA5 * rB5;
            rC6_5 += rA6 * rB5;
            rC0_6 += rA0 * rB6;
            rC1_6 += rA1 * rB6;
            rC2_6 += rA2 * rB6;
            rC3_6 += rA3 * rB6;
            rC4_6 += rA4 * rB6;
            rC5_6 += rA5 * rB6;
            rC6_6 += rA6 * rB6;
            rC0_7 += rA0 * rB7;
            rC1_7 += rA1 * rB7;
            rC2_7 += rA2 * rB7;
            rC3_7 += rA3 * rB7;
            rC4_7 += rA4 * rB7;
            rC5_7 += rA5 * rB7;
            rC6_7 += rA6 * rB7;
            rC0_8 += rA0 * rB8;
            rC1_8 += rA1 * rB8;
            rC2_8 += rA2 * rB8;
            rC3_8 += rA3 * rB8;
            rC4_8 += rA4 * rB8;
            rC5_8 += rA5 * rB8;
            rC6_8 += rA6 * rB8;
            rC0_9 += rA0 * rB9;
            rC1_9 += rA1 * rB9;
            rC2_9 += rA2 * rB9;
            rC3_9 += rA3 * rB9;
            rC4_9 += rA4 * rB9;
            rC5_9 += rA5 * rB9;
            rC6_9 += rA6 * rB9;
            rC0_10 += rA0 * rB10;
            rC1_10 += rA1 * rB10;
            rC2_10 += rA2 * rB10;
            rC3_10 += rA3 * rB10;
            rC4_10 += rA4 * rB10;
            rC5_10 += rA5 * rB10;
            rC6_10 += rA6 * rB10;
            rC0_11 += rA0 * rB11;
            rC1_11 += rA1 * rB11;
            rC2_11 += rA2 * rB11;
            rC3_11 += rA3 * rB11;
            rC4_11 += rA4 * rB11;
            rC5_11 += rA5 * rB11;
            rC6_11 += rA6 * rB11;
            rC0_12 += rA0 * rB12;
            rC1_12 += rA1 * rB12;
            rC2_12 += rA2 * rB12;
            rC3_12 += rA3 * rB12;
            rC4_12 += rA4 * rB12;
            rC5_12 += rA5 * rB12;
            rC6_12 += rA6 * rB12;
            rC0_13 += rA0 * rB13;
            rC1_13 += rA1 * rB13;
            rC2_13 += rA2 * rB13;
            rC3_13 += rA3 * rB13;
            rC4_13 += rA4 * rB13;
            rC5_13 += rA5 * rB13;
            rC6_13 += rA6 * rB13;
            rC0_14 += rA0 * rB14;
            rC1_14 += rA1 * rB14;
            rC2_14 += rA2 * rB14;
            rC3_14 += rA3 * rB14;
            rC4_14 += rA4 * rB14;
            rC5_14 += rA5 * rB14;
            rC6_14 += rA6 * rB14;
            rC0_15 += rA0 * rB15;
            rC1_15 += rA1 * rB15;
            rC2_15 += rA2 * rB15;
            rC3_15 += rA3 * rB15;
            rC4_15 += rA4 * rB15;
            rC5_15 += rA5 * rB15;
            rC6_15 += rA6 * rB15;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rA1 = pA1[2];
            rA2 = pA2[2];
            rA3 = pA3[2];
            rA4 = pA4[2];
            rA5 = pA5[2];
            rA6 = pA6[2];
            rC0_0 += rA0 * rB0;
            rB1 = pB1[2];
            rB2 = pB2[2];
            rB3 = pB3[2];
            rB4 = pB4[2];
            rB5 = pB5[2];
            rB6 = pB6[2];
            rB7 = pB7[2];
            rC1_0 += rA1 * rB0;
            rB8 = pB8[2];
            rB9 = pB9[2];
            rB10 = pB10[2];
            rB11 = pB11[2];
            rB12 = pB12[2];
            rB13 = pB13[2];
            rB14 = pB14[2];
            rC2_0 += rA2 * rB0;
            rB15 = pB15[2];
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rC6_0 += rA6 * rB0;
            rC0_1 += rA0 * rB1;
            rC1_1 += rA1 * rB1;
            rC2_1 += rA2 * rB1;
            rC3_1 += rA3 * rB1;
            rC4_1 += rA4 * rB1;
            rC5_1 += rA5 * rB1;
            rC6_1 += rA6 * rB1;
            rC0_2 += rA0 * rB2;
            rC1_2 += rA1 * rB2;
            rC2_2 += rA2 * rB2;
            rC3_2 += rA3 * rB2;
            rC4_2 += rA4 * rB2;
            rC5_2 += rA5 * rB2;
            rC6_2 += rA6 * rB2;
            rC0_3 += rA0 * rB3;
            rC1_3 += rA1 * rB3;
            rC2_3 += rA2 * rB3;
            rC3_3 += rA3 * rB3;
            rC4_3 += rA4 * rB3;
            rC5_3 += rA5 * rB3;
            rC6_3 += rA6 * rB3;
            rC0_4 += rA0 * rB4;
            rC1_4 += rA1 * rB4;
            rC2_4 += rA2 * rB4;
            rC3_4 += rA3 * rB4;
            rC4_4 += rA4 * rB4;
            rC5_4 += rA5 * rB4;
            rC6_4 += rA6 * rB4;
            rC0_5 += rA0 * rB5;
            rC1_5 += rA1 * rB5;
            rC2_5 += rA2 * rB5;
            rC3_5 += rA3 * rB5;
            rC4_5 += rA4 * rB5;
            rC5_5 += rA5 * rB5;
            rC6_5 += rA6 * rB5;
            rC0_6 += rA0 * rB6;
            rC1_6 += rA1 * rB6;
            rC2_6 += rA2 * rB6;
            rC3_6 += rA3 * rB6;
            rC4_6 += rA4 * rB6;
            rC5_6 += rA5 * rB6;
            rC6_6 += rA6 * rB6;
            rC0_7 += rA0 * rB7;
            rC1_7 += rA1 * rB7;
            rC2_7 += rA2 * rB7;
            rC3_7 += rA3 * rB7;
            rC4_7 += rA4 * rB7;
            rC5_7 += rA5 * rB7;
            rC6_7 += rA6 * rB7;
            rC0_8 += rA0 * rB8;
            rC1_8 += rA1 * rB8;
            rC2_8 += rA2 * rB8;
            rC3_8 += rA3 * rB8;
            rC4_8 += rA4 * rB8;
            rC5_8 += rA5 * rB8;
            rC6_8 += rA6 * rB8;
            rC0_9 += rA0 * rB9;
            rC1_9 += rA1 * rB9;
            rC2_9 += rA2 * rB9;
            rC3_9 += rA3 * rB9;
            rC4_9 += rA4 * rB9;
            rC5_9 += rA5 * rB9;
            rC6_9 += rA6 * rB9;
            rC0_10 += rA0 * rB10;
            rC1_10 += rA1 * rB10;
            rC2_10 += rA2 * rB10;
            rC3_10 += rA3 * rB10;
            rC4_10 += rA4 * rB10;
            rC5_10 += rA5 * rB10;
            rC6_10 += rA6 * rB10;
            rC0_11 += rA0 * rB11;
            rC1_11 += rA1 * rB11;
            rC2_11 += rA2 * rB11;
            rC3_11 += rA3 * rB11;
            rC4_11 += rA4 * rB11;
            rC5_11 += rA5 * rB11;
            rC6_11 += rA6 * rB11;
            rC0_12 += rA0 * rB12;
            rC1_12 += rA1 * rB12;
            rC2_12 += rA2 * rB12;
            rC3_12 += rA3 * rB12;
            rC4_12 += rA4 * rB12;
            rC5_12 += rA5 * rB12;
            rC6_12 += rA6 * rB12;
            rC0_13 += rA0 * rB13;
            rC1_13 += rA1 * rB13;
            rC2_13 += rA2 * rB13;
            rC3_13 += rA3 * rB13;
            rC4_13 += rA4 * rB13;
            rC5_13 += rA5 * rB13;
            rC6_13 += rA6 * rB13;
            rC0_14 += rA0 * rB14;
            rC1_14 += rA1 * rB14;
            rC2_14 += rA2 * rB14;
            rC3_14 += rA3 * rB14;
            rC4_14 += rA4 * rB14;
            rC5_14 += rA5 * rB14;
            rC6_14 += rA6 * rB14;
            rC0_15 += rA0 * rB15;
            rC1_15 += rA1 * rB15;
            rC2_15 += rA2 * rB15;
            rC3_15 += rA3 * rB15;
            rC4_15 += rA4 * rB15;
            rC5_15 += rA5 * rB15;
            rC6_15 += rA6 * rB15;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rA1 = pA1[3];
            rA2 = pA2[3];
            rA3 = pA3[3];
            rA4 = pA4[3];
            rA5 = pA5[3];
            rA6 = pA6[3];
            rC0_0 += rA0 * rB0;
            rB1 = pB1[3];
            rB2 = pB2[3];
            rB3 = pB3[3];
            rB4 = pB4[3];
            rB5 = pB5[3];
            rB6 = pB6[3];
            rB7 = pB7[3];
            rC1_0 += rA1 * rB0;
            rB8 = pB8[3];
            rB9 = pB9[3];
            rB10 = pB10[3];
            rB11 = pB11[3];
            rB12 = pB12[3];
            rB13 = pB13[3];
            rB14 = pB14[3];
            rC2_0 += rA2 * rB0;
            rB15 = pB15[3];
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rC6_0 += rA6 * rB0;
            rC0_1 += rA0 * rB1;
            rC1_1 += rA1 * rB1;
            rC2_1 += rA2 * rB1;
            rC3_1 += rA3 * rB1;
            rC4_1 += rA4 * rB1;
            rC5_1 += rA5 * rB1;
            rC6_1 += rA6 * rB1;
            rC0_2 += rA0 * rB2;
            rC1_2 += rA1 * rB2;
            rC2_2 += rA2 * rB2;
            rC3_2 += rA3 * rB2;
            rC4_2 += rA4 * rB2;
            rC5_2 += rA5 * rB2;
            rC6_2 += rA6 * rB2;
            rC0_3 += rA0 * rB3;
            rC1_3 += rA1 * rB3;
            rC2_3 += rA2 * rB3;
            rC3_3 += rA3 * rB3;
            rC4_3 += rA4 * rB3;
            rC5_3 += rA5 * rB3;
            rC6_3 += rA6 * rB3;
            rC0_4 += rA0 * rB4;
            rC1_4 += rA1 * rB4;
            rC2_4 += rA2 * rB4;
            rC3_4 += rA3 * rB4;
            rC4_4 += rA4 * rB4;
            rC5_4 += rA5 * rB4;
            rC6_4 += rA6 * rB4;
            rC0_5 += rA0 * rB5;
            rC1_5 += rA1 * rB5;
            rC2_5 += rA2 * rB5;
            rC3_5 += rA3 * rB5;
            rC4_5 += rA4 * rB5;
            rC5_5 += rA5 * rB5;
            rC6_5 += rA6 * rB5;
            rC0_6 += rA0 * rB6;
            rC1_6 += rA1 * rB6;
            rC2_6 += rA2 * rB6;
            rC3_6 += rA3 * rB6;
            rC4_6 += rA4 * rB6;
            rC5_6 += rA5 * rB6;
            rC6_6 += rA6 * rB6;
            rC0_7 += rA0 * rB7;
            rC1_7 += rA1 * rB7;
            rC2_7 += rA2 * rB7;
            rC3_7 += rA3 * rB7;
            rC4_7 += rA4 * rB7;
            rC5_7 += rA5 * rB7;
            rC6_7 += rA6 * rB7;
            rC0_8 += rA0 * rB8;
            rC1_8 += rA1 * rB8;
            rC2_8 += rA2 * rB8;
            rC3_8 += rA3 * rB8;
            rC4_8 += rA4 * rB8;
            rC5_8 += rA5 * rB8;
            rC6_8 += rA6 * rB8;
            rC0_9 += rA0 * rB9;
            rC1_9 += rA1 * rB9;
            rC2_9 += rA2 * rB9;
            rC3_9 += rA3 * rB9;
            rC4_9 += rA4 * rB9;
            rC5_9 += rA5 * rB9;
            rC6_9 += rA6 * rB9;
            rC0_10 += rA0 * rB10;
            rC1_10 += rA1 * rB10;
            rC2_10 += rA2 * rB10;
            rC3_10 += rA3 * rB10;
            rC4_10 += rA4 * rB10;
            rC5_10 += rA5 * rB10;
            rC6_10 += rA6 * rB10;
            rC0_11 += rA0 * rB11;
            rC1_11 += rA1 * rB11;
            rC2_11 += rA2 * rB11;
            rC3_11 += rA3 * rB11;
            rC4_11 += rA4 * rB11;
            rC5_11 += rA5 * rB11;
            rC6_11 += rA6 * rB11;
            rC0_12 += rA0 * rB12;
            rC1_12 += rA1 * rB12;
            rC2_12 += rA2 * rB12;
            rC3_12 += rA3 * rB12;
            rC4_12 += rA4 * rB12;
            rC5_12 += rA5 * rB12;
            rC6_12 += rA6 * rB12;
            rC0_13 += rA0 * rB13;
            rC1_13 += rA1 * rB13;
            rC2_13 += rA2 * rB13;
            rC3_13 += rA3 * rB13;
            rC4_13 += rA4 * rB13;
            rC5_13 += rA5 * rB13;
            rC6_13 += rA6 * rB13;
            rC0_14 += rA0 * rB14;
            rC1_14 += rA1 * rB14;
            rC2_14 += rA2 * rB14;
            rC3_14 += rA3 * rB14;
            rC4_14 += rA4 * rB14;
            rC5_14 += rA5 * rB14;
            rC6_14 += rA6 * rB14;
            rC0_15 += rA0 * rB15;
            rC1_15 += rA1 * rB15;
            rC2_15 += rA2 * rB15;
            rC3_15 += rA3 * rB15;
            rC4_15 += rA4 * rB15;
            rC5_15 += rA5 * rB15;
            rC6_15 += rA6 * rB15;
            pA0 += incAk;
            pA1 += incAk;
            pA2 += incAk;
            pA3 += incAk;
            pA4 += incAk;
            pA5 += incAk;
            pA6 += incAk;
            pB0 += incBk;
            pB1 += incBk;
            pB2 += incBk;
            pB3 += incBk;
            pB4 += incBk;
            pB5 += incBk;
            pB6 += incBk;
            pB7 += incBk;
            pB8 += incBk;
            pB9 += incBk;
            pB10 += incBk;
            pB11 += incBk;
            pB12 += incBk;
            pB13 += incBk;
            pB14 += incBk;
            pB15 += incBk;
         }
         rB0 = alpha;
         rC0_0 *= rB0;
         rC0_1 *= rB0;
         rC0_2 *= rB0;
         rC0_3 *= rB0;
         rC0_4 *= rB0;
         rC0_5 *= rB0;
         rC0_6 *= rB0;
         rC0_7 *= rB0;
         rC0_8 *= rB0;
         rC0_9 *= rB0;
         rC0_10 *= rB0;
         rC0_11 *= rB0;
         rC0_12 *= rB0;
         rC0_13 *= rB0;
         rC0_14 *= rB0;
         rC0_15 *= rB0;
         rC1_0 *= rB0;
         rC1_1 *= rB0;
         rC1_2 *= rB0;
         rC1_3 *= rB0;
         rC1_4 *= rB0;
         rC1_5 *= rB0;
         rC1_6 *= rB0;
         rC1_7 *= rB0;
         rC1_8 *= rB0;
         rC1_9 *= rB0;
         rC1_10 *= rB0;
         rC1_11 *= rB0;
         rC1_12 *= rB0;
         rC1_13 *= rB0;
         rC1_14 *= rB0;
         rC1_15 *= rB0;
         rC2_0 *= rB0;
         rC2_1 *= rB0;
         rC2_2 *= rB0;
         rC2_3 *= rB0;
         rC2_4 *= rB0;
         rC2_5 *= rB0;
         rC2_6 *= rB0;
         rC2_7 *= rB0;
         rC2_8 *= rB0;
         rC2_9 *= rB0;
         rC2_10 *= rB0;
         rC2_11 *= rB0;
         rC2_12 *= rB0;
         rC2_13 *= rB0;
         rC2_14 *= rB0;
         rC2_15 *= rB0;
         rC3_0 *= rB0;
         rC3_1 *= rB0;
         rC3_2 *= rB0;
         rC3_3 *= rB0;
         rC3_4 *= rB0;
         rC3_5 *= rB0;
         rC3_6 *= rB0;
         rC3_7 *= rB0;
         rC3_8 *= rB0;
         rC3_9 *= rB0;
         rC3_10 *= rB0;
         rC3_11 *= rB0;
         rC3_12 *= rB0;
         rC3_13 *= rB0;
         rC3_14 *= rB0;
         rC3_15 *= rB0;
         rC4_0 *= rB0;
         rC4_1 *= rB0;
         rC4_2 *= rB0;
         rC4_3 *= rB0;
         rC4_4 *= rB0;
         rC4_5 *= rB0;
         rC4_6 *= rB0;
         rC4_7 *= rB0;
         rC4_8 *= rB0;
         rC4_9 *= rB0;
         rC4_10 *= rB0;
         rC4_11 *= rB0;
         rC4_12 *= rB0;
         rC4_13 *= rB0;
         rC4_14 *= rB0;
         rC4_15 *= rB0;
         rC5_0 *= rB0;
         rC5_1 *= rB0;
         rC5_2 *= rB0;
         rC5_3 *= rB0;
         rC5_4 *= rB0;
         rC5_5 *= rB0;
         rC5_6 *= rB0;
         rC5_7 *= rB0;
         rC5_8 *= rB0;
         rC5_9 *= rB0;
         rC5_10 *= rB0;
         rC5_11 *= rB0;
         rC5_12 *= rB0;
         rC5_13 *= rB0;
         rC5_14 *= rB0;
         rC5_15 *= rB0;
         rC6_0 *= rB0;
         rC6_1 *= rB0;
         rC6_2 *= rB0;
         rC6_3 *= rB0;
         rC6_4 *= rB0;
         rC6_5 *= rB0;
         rC6_6 *= rB0;
         rC6_7 *= rB0;
         rC6_8 *= rB0;
         rC6_9 *= rB0;
         rC6_10 *= rB0;
         rC6_11 *= rB0;
         rC6_12 *= rB0;
         rC6_13 *= rB0;
         rC6_14 *= rB0;
         rC6_15 *= rB0;
         *pC0 = rC0_0;
         pC0[1] = rC1_0;
         pC0[2] = rC2_0;
         pC0[3] = rC3_0;
         pC0[4] = rC4_0;
         pC0[5] = rC5_0;
         pC0[6] = rC6_0;
         *pC1 = rC0_1;
         pC1[1] = rC1_1;
         pC1[2] = rC2_1;
         pC1[3] = rC3_1;
         pC1[4] = rC4_1;
         pC1[5] = rC5_1;
         pC1[6] = rC6_1;
         *pC2 = rC0_2;
         pC2[1] = rC1_2;
         pC2[2] = rC2_2;
         pC2[3] = rC3_2;
         pC2[4] = rC4_2;
         pC2[5] = rC5_2;
         pC2[6] = rC6_2;
         *pC3 = rC0_3;
         pC3[1] = rC1_3;
         pC3[2] = rC2_3;
         pC3[3] = rC3_3;
         pC3[4] = rC4_3;
         pC3[5] = rC5_3;
         pC3[6] = rC6_3;
         *pC4 = rC0_4;
         pC4[1] = rC1_4;
         pC4[2] = rC2_4;
         pC4[3] = rC3_4;
         pC4[4] = rC4_4;
         pC4[5] = rC5_4;
         pC4[6] = rC6_4;
         *pC5 = rC0_5;
         pC5[1] = rC1_5;
         pC5[2] = rC2_5;
         pC5[3] = rC3_5;
         pC5[4] = rC4_5;
         pC5[5] = rC5_5;
         pC5[6] = rC6_5;
         *pC6 = rC0_6;
         pC6[1] = rC1_6;
         pC6[2] = rC2_6;
         pC6[3] = rC3_6;
         pC6[4] = rC4_6;
         pC6[5] = rC5_6;
         pC6[6] = rC6_6;
         *pC7 = rC0_7;
         pC7[1] = rC1_7;
         pC7[2] = rC2_7;
         pC7[3] = rC3_7;
         pC7[4] = rC4_7;
         pC7[5] = rC5_7;
         pC7[6] = rC6_7;
         *pC8 = rC0_8;
         pC8[1] = rC1_8;
         pC8[2] = rC2_8;
         pC8[3] = rC3_8;
         pC8[4] = rC4_8;
         pC8[5] = rC5_8;
         pC8[6] = rC6_8;
         *pC9 = rC0_9;
         pC9[1] = rC1_9;
         pC9[2] = rC2_9;
         pC9[3] = rC3_9;
         pC9[4] = rC4_9;
         pC9[5] = rC5_9;
         pC9[6] = rC6_9;
         *pC10 = rC0_10;
         pC10[1] = rC1_10;
         pC10[2] = rC2_10;
         pC10[3] = rC3_10;
         pC10[4] = rC4_10;
         pC10[5] = rC5_10;
         pC10[6] = rC6_10;
         *pC11 = rC0_11;
         pC11[1] = rC1_11;
         pC11[2] = rC2_11;
         pC11[3] = rC3_11;
         pC11[4] = rC4_11;
         pC11[5] = rC5_11;
         pC11[6] = rC6_11;
         *pC12 = rC0_12;
         pC12[1] = rC1_12;
         pC12[2] = rC2_12;
         pC12[3] = rC3_12;
         pC12[4] = rC4_12;
         pC12[5] = rC5_12;
         pC12[6] = rC6_12;
         *pC13 = rC0_13;
         pC13[1] = rC1_13;
         pC13[2] = rC2_13;
         pC13[3] = rC3_13;
         pC13[4] = rC4_13;
         pC13[5] = rC5_13;
         pC13[6] = rC6_13;
         *pC14 = rC0_14;
         pC14[1] = rC1_14;
         pC14[2] = rC2_14;
         pC14[3] = rC3_14;
         pC14[4] = rC4_14;
         pC14[5] = rC5_14;
         pC14[6] = rC6_14;
         *pC15 = rC0_15;
         pC15[1] = rC1_15;
         pC15[2] = rC2_15;
         pC15[3] = rC3_15;
         pC15[4] = rC4_15;
         pC15[5] = rC5_15;
         pC15[6] = rC6_15;
         pC0 += incCm;
         pC1 += incCm;
         pC2 += incCm;
         pC3 += incCm;
         pC4 += incCm;
         pC5 += incCm;
         pC6 += incCm;
         pC7 += incCm;
         pC8 += incCm;
         pC9 += incCm;
         pC10 += incCm;
         pC11 += incCm;
         pC12 += incCm;
         pC13 += incCm;
         pC14 += incCm;
         pC15 += incCm;
         pA0 += incAm;
         pA1 += incAm;
         pA2 += incAm;
         pA3 += incAm;
         pA4 += incAm;
         pA5 += incAm;
         pA6 += incAm;
         pB0 += incBm;
         pB1 += incBm;
         pB2 += incBm;
         pB3 += incBm;
         pB4 += incBm;
         pB5 += incBm;
         pB6 += incBm;
         pB7 += incBm;
         pB8 += incBm;
         pB9 += incBm;
         pB10 += incBm;
         pB11 += incBm;
         pB12 += incBm;
         pB13 += incBm;
         pB14 += incBm;
         pB15 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pC4 += incCn;
      pC5 += incCn;
      pC6 += incCn;
      pC7 += incCn;
      pC8 += incCn;
      pC9 += incCn;
      pC10 += incCn;
      pC11 += incCn;
      pC12 += incCn;
      pC13 += incCn;
      pC14 += incCn;
      pC15 += incCn;
      pA0 += incAn;
      pA1 += incAn;
      pA2 += incAn;
      pA3 += incAn;
      pA4 += incAn;
      pA5 += incAn;
      pA6 += incAn;
      pB0 += incBn;
      pB1 += incBn;
      pB2 += incBn;
      pB3 += incBn;
      pB4 += incBn;
      pB5 += incBn;
      pB6 += incBn;
      pB7 += incBn;
      pB8 += incBn;
      pB9 += incBn;
      pB10 += incBn;
      pB11 += incBn;
      pB12 += incBn;
      pB13 += incBn;
      pB14 += incBn;
      pB15 += incBn;
   }
   while(pB0 != stN);
   ATL_dJIK1x64x64TN1x16x4_aX_b0(1, 64, 64, alpha, ca + (63*(lda)), lda, cb, ldb, beta, cc + 63, ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
