#ifdef ATL_UCLEANM
#define ATL_dJIK0x48x48TN48x48x0_a1_bX ATL_dgpMBmm_bX
#else
#define ATL_dJIK0x48x48TN48x48x0_a1_bX ATL_dpMBmm_bX
#endif

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_dJIK0x3x48TN1x3x1_a1_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=3, KB=48, 
 * lda=48, ldb=48, ldc=0, mu=1, nu=3, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Mb M
   const double *stM = A + (((Mb) << 5)+((Mb) << 4));
   const double *stN = B + 144;
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*1*3)/(M*N*sizeof(double));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 1
   const int incAm = 0, incAn = -(((Mb) << 5)+((Mb) << 4));
   #define incBk 1
   const int incBm = -48, incBn = 144;
   #define incCm 1
   const int incCn = (((ldc) << 1)+ldc) - (Mb);
   double *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc);
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0;
   register double rB0, rB1, rB2;
   register double rC0_0, rC0_1, rC0_2;
   do /* M-loop */
   {
      ATL_pfl1R(pfA);
      ATL_pfl1R(pfA+ATL_L1LS);
      ATL_pfl1R(pfA+3*ATL_L1LS);
      ATL_pfl1R(pfA+4*ATL_L1LS);
      ATL_pfl1R(pfA+5*ATL_L1LS);
      pfA += incPFA;
      rA0 = beta;
      rC0_0 = *pC0;
      rC0_0 *= rA0;
      rC0_1 = *pC1;
      rC0_1 *= rA0;
      rC0_2 = *pC2;
      rC0_2 *= rA0;
      for (k=48; k; k--) /* easy loop to unroll */
      {
         rA0 = *pA0;
         rB0 = *pB0;
         rB1 = pB0[48];
         rB2 = pB0[96];
         rC0_0 += rA0 * rB0;
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         pA0 += incAk;
         pB0 += incBk;
      }
      *pC0 = rC0_0;
      *pC1 = rC0_1;
      *pC2 = rC0_2;
      pC0 += incCm;
      pC1 += incCm;
      pC2 += incCm;
      pA0 += incAm;
      pB0 += incBm;
   }
   while(pA0 != stM);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
static void ATL_dJIK0x3x48TN7x3x1_a1_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=3, KB=48, 
 * lda=48, ldb=48, ldc=0, mu=7, nu=3, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const int Mb = (M/7)*7;
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + (((Mb) << 5)+((Mb) << 4));
   const double *stN = B + 144;
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*7*3)/(M*N*sizeof(double));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 1
   const int incAm = 288, incAn = -(((Mb) << 5)+((Mb) << 4));
   #define incBk 1
   const int incBm = -48, incBn = 144;
   #define incCm 7
   const int incCn = (((ldc) << 1)+ldc) - (Mb);
   double *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc);
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0, rA1, rA2, rA3, rA4, rA5, rA6;
   register double rB0, rB1, rB2;
   register double rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0, rC6_0, rC0_1, rC1_1, rC2_1, rC3_1, rC4_1, rC5_1, rC6_1, rC0_2, rC1_2, rC2_2, rC3_2, rC4_2, rC5_2, rC6_2;
   if (pA0 != stM)
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         ATL_pfl1R(pfA+ATL_L1LS);
         ATL_pfl1R(pfA+3*ATL_L1LS);
         ATL_pfl1R(pfA+4*ATL_L1LS);
         ATL_pfl1R(pfA+5*ATL_L1LS);
         ATL_pfl1R(pfA+6*ATL_L1LS);
         ATL_pfl1R(pfA+7*ATL_L1LS);
         ATL_pfl1R(pfA+8*ATL_L1LS);
         ATL_pfl1R(pfA+9*ATL_L1LS);
         ATL_pfl1R(pfA+10*ATL_L1LS);
         ATL_pfl1R(pfA+11*ATL_L1LS);
         ATL_pfl1R(pfA+12*ATL_L1LS);
         ATL_pfl1R(pfA+13*ATL_L1LS);
         ATL_pfl1R(pfA+14*ATL_L1LS);
         ATL_pfl1R(pfA+15*ATL_L1LS);
         ATL_pfl1R(pfA+16*ATL_L1LS);
         ATL_pfl1R(pfA+17*ATL_L1LS);
         ATL_pfl1R(pfA+18*ATL_L1LS);
         ATL_pfl1R(pfA+19*ATL_L1LS);
         ATL_pfl1R(pfA+20*ATL_L1LS);
         ATL_pfl1R(pfA+21*ATL_L1LS);
         ATL_pfl1R(pfA+22*ATL_L1LS);
         ATL_pfl1R(pfA+23*ATL_L1LS);
         ATL_pfl1R(pfA+24*ATL_L1LS);
         ATL_pfl1R(pfA+25*ATL_L1LS);
         ATL_pfl1R(pfA+26*ATL_L1LS);
         ATL_pfl1R(pfA+27*ATL_L1LS);
         ATL_pfl1R(pfA+28*ATL_L1LS);
         ATL_pfl1R(pfA+29*ATL_L1LS);
         ATL_pfl1R(pfA+30*ATL_L1LS);
         ATL_pfl1R(pfA+31*ATL_L1LS);
         ATL_pfl1R(pfA+32*ATL_L1LS);
         ATL_pfl1R(pfA+33*ATL_L1LS);
         ATL_pfl1R(pfA+34*ATL_L1LS);
         ATL_pfl1R(pfA+35*ATL_L1LS);
         ATL_pfl1R(pfA+36*ATL_L1LS);
         ATL_pfl1R(pfA+37*ATL_L1LS);
         ATL_pfl1R(pfA+38*ATL_L1LS);
         ATL_pfl1R(pfA+39*ATL_L1LS);
         ATL_pfl1R(pfA+40*ATL_L1LS);
         ATL_pfl1R(pfA+41*ATL_L1LS);
         pfA += incPFA;
         rA0 = beta;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         rC1_0 = pC0[1];
         rC1_0 *= rA0;
         rC2_0 = pC0[2];
         rC2_0 *= rA0;
         rC3_0 = pC0[3];
         rC3_0 *= rA0;
         rC4_0 = pC0[4];
         rC4_0 *= rA0;
         rC5_0 = pC0[5];
         rC5_0 *= rA0;
         rC6_0 = pC0[6];
         rC6_0 *= rA0;
         rC0_1 = *pC1;
         rC0_1 *= rA0;
         rC1_1 = pC1[1];
         rC1_1 *= rA0;
         rC2_1 = pC1[2];
         rC2_1 *= rA0;
         rC3_1 = pC1[3];
         rC3_1 *= rA0;
         rC4_1 = pC1[4];
         rC4_1 *= rA0;
         rC5_1 = pC1[5];
         rC5_1 *= rA0;
         rC6_1 = pC1[6];
         rC6_1 *= rA0;
         rC0_2 = *pC2;
         rC0_2 *= rA0;
         rC1_2 = pC2[1];
         rC1_2 *= rA0;
         rC2_2 = pC2[2];
         rC2_2 *= rA0;
         rC3_2 = pC2[3];
         rC3_2 *= rA0;
         rC4_2 = pC2[4];
         rC4_2 *= rA0;
         rC5_2 = pC2[5];
         rC5_2 *= rA0;
         rC6_2 = pC2[6];
         rC6_2 *= rA0;
         for (k=48; k; k--) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = pA0[48];
            rA2 = pA0[96];
            rA3 = pA0[144];
            rA4 = pA0[192];
            rA5 = pA0[240];
            rC0_0 += rA0 * rB0;
            rA6 = pA0[288];
            rC1_0 += rA1 * rB0;
            rB1 = pB0[48];
            rC2_0 += rA2 * rB0;
            rB2 = pB0[96];
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rC6_0 += rA6 * rB0;
            rC0_1 += rA0 * rB1;
            rC1_1 += rA1 * rB1;
            rC2_1 += rA2 * rB1;
            rC3_1 += rA3 * rB1;
            rC4_1 += rA4 * rB1;
            rC5_1 += rA5 * rB1;
            rC6_1 += rA6 * rB1;
            rC0_2 += rA0 * rB2;
            rC1_2 += rA1 * rB2;
            rC2_2 += rA2 * rB2;
            rC3_2 += rA3 * rB2;
            rC4_2 += rA4 * rB2;
            rC5_2 += rA5 * rB2;
            rC6_2 += rA6 * rB2;
            pA0 += incAk;
            pB0 += incBk;
         }
         *pC0 = rC0_0;
         pC0[1] = rC1_0;
         pC0[2] = rC2_0;
         pC0[3] = rC3_0;
         pC0[4] = rC4_0;
         pC0[5] = rC5_0;
         pC0[6] = rC6_0;
         *pC1 = rC0_1;
         pC1[1] = rC1_1;
         pC1[2] = rC2_1;
         pC1[3] = rC3_1;
         pC1[4] = rC4_1;
         pC1[5] = rC5_1;
         pC1[6] = rC6_1;
         *pC2 = rC0_2;
         pC2[1] = rC1_2;
         pC2[2] = rC2_2;
         pC2[3] = rC3_2;
         pC2[4] = rC4_2;
         pC2[5] = rC5_2;
         pC2[6] = rC6_2;
         pC0 += incCm;
         pC1 += incCm;
         pC2 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
   }
   if (k=M-Mb)
      ATL_dJIK0x3x48TN1x3x1_a1_bX(k, 3, 48, alpha, ca + (((Mb) << 5)+((Mb) << 4)), lda, cb, ldb, beta, cc + (Mb), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_dJIK0x45x48TN1x15x1_a1_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=45, KB=48, 
 * lda=48, ldb=48, ldc=0, mu=1, nu=15, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Mb M
   const double *stM = A + (((Mb) << 5)+((Mb) << 4));
   const double *stN = B + 2160;
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*1*15)/(M*N*sizeof(double));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 1
   const int incAm = 0, incAn = -(((Mb) << 5)+((Mb) << 4));
   #define incBk 1
   const int incBm = -48, incBn = 720;
   #define incCm 1
   const int incCn = (15*(ldc)) - (Mb);
   double *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc), *pC4=pC3+(ldc), *pC5=pC4+(ldc), *pC6=pC5+(ldc), *pC7=pC6+(ldc), *pC8=pC7+(ldc), *pC9=pC8+(ldc), *pC10=pC9+(ldc), *pC11=pC10+(ldc), *pC12=pC11+(ldc), *pC13=pC12+(ldc), *pC14=pC13+(ldc);
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0;
   register double rB0, rB1, rB2, rB3, rB4, rB5, rB6, rB7, rB8, rB9, rB10, rB11, rB12, rB13, rB14;
   register double rC0_0, rC0_1, rC0_2, rC0_3, rC0_4, rC0_5, rC0_6, rC0_7, rC0_8, rC0_9, rC0_10, rC0_11, rC0_12, rC0_13, rC0_14;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         ATL_pfl1R(pfA+ATL_L1LS);
         pfA += incPFA;
         rA0 = beta;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         rC0_1 = *pC1;
         rC0_1 *= rA0;
         rC0_2 = *pC2;
         rC0_2 *= rA0;
         rC0_3 = *pC3;
         rC0_3 *= rA0;
         rC0_4 = *pC4;
         rC0_4 *= rA0;
         rC0_5 = *pC5;
         rC0_5 *= rA0;
         rC0_6 = *pC6;
         rC0_6 *= rA0;
         rC0_7 = *pC7;
         rC0_7 *= rA0;
         rC0_8 = *pC8;
         rC0_8 *= rA0;
         rC0_9 = *pC9;
         rC0_9 *= rA0;
         rC0_10 = *pC10;
         rC0_10 *= rA0;
         rC0_11 = *pC11;
         rC0_11 *= rA0;
         rC0_12 = *pC12;
         rC0_12 *= rA0;
         rC0_13 = *pC13;
         rC0_13 *= rA0;
         rC0_14 = *pC14;
         rC0_14 *= rA0;
         for (k=48; k; k--) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rB1 = pB0[48];
            rB2 = pB0[96];
            rB3 = pB0[144];
            rB4 = pB0[192];
            rB5 = pB0[240];
            rC0_0 += rA0 * rB0;
            rB6 = pB0[288];
            rC0_1 += rA0 * rB1;
            rB7 = pB0[336];
            rC0_2 += rA0 * rB2;
            rB8 = pB0[384];
            rC0_3 += rA0 * rB3;
            rB9 = pB0[432];
            rC0_4 += rA0 * rB4;
            rB10 = pB0[480];
            rC0_5 += rA0 * rB5;
            rB11 = pB0[528];
            rC0_6 += rA0 * rB6;
            rB12 = pB0[576];
            rC0_7 += rA0 * rB7;
            rB13 = pB0[624];
            rC0_8 += rA0 * rB8;
            rB14 = pB0[672];
            rC0_9 += rA0 * rB9;
            rC0_10 += rA0 * rB10;
            rC0_11 += rA0 * rB11;
            rC0_12 += rA0 * rB12;
            rC0_13 += rA0 * rB13;
            rC0_14 += rA0 * rB14;
            pA0 += incAk;
            pB0 += incBk;
         }
         *pC0 = rC0_0;
         *pC1 = rC0_1;
         *pC2 = rC0_2;
         *pC3 = rC0_3;
         *pC4 = rC0_4;
         *pC5 = rC0_5;
         *pC6 = rC0_6;
         *pC7 = rC0_7;
         *pC8 = rC0_8;
         *pC9 = rC0_9;
         *pC10 = rC0_10;
         *pC11 = rC0_11;
         *pC12 = rC0_12;
         *pC13 = rC0_13;
         *pC14 = rC0_14;
         pC0 += incCm;
         pC1 += incCm;
         pC2 += incCm;
         pC3 += incCm;
         pC4 += incCm;
         pC5 += incCm;
         pC6 += incCm;
         pC7 += incCm;
         pC8 += incCm;
         pC9 += incCm;
         pC10 += incCm;
         pC11 += incCm;
         pC12 += incCm;
         pC13 += incCm;
         pC14 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pC4 += incCn;
      pC5 += incCn;
      pC6 += incCn;
      pC7 += incCn;
      pC8 += incCn;
      pC9 += incCn;
      pC10 += incCn;
      pC11 += incCn;
      pC12 += incCn;
      pC13 += incCn;
      pC14 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_dJIK0x48x48TN48x48x0_a1_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=48, KB=48, 
 * lda=48, ldb=48, ldc=0, mu=7, nu=15, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const int Mb = (M/7)*7;
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + (((Mb) << 5)+((Mb) << 4));
   const double *stN = B + 2160;
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*7*15)/(M*N*sizeof(double));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 1
   const int incAm = 288, incAn = -(((Mb) << 5)+((Mb) << 4));
   #define incBk 1
   const int incBm = -48, incBn = 720;
   #define incCm 7
   const int incCn = (15*(ldc)) - (Mb);
   double *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc), *pC4=pC3+(ldc), *pC5=pC4+(ldc), *pC6=pC5+(ldc), *pC7=pC6+(ldc), *pC8=pC7+(ldc), *pC9=pC8+(ldc), *pC10=pC9+(ldc), *pC11=pC10+(ldc), *pC12=pC11+(ldc), *pC13=pC12+(ldc), *pC14=pC13+(ldc);
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0, rA1, rA2, rA3, rA4, rA5, rA6;
   register double rB0, rB1, rB2, rB3, rB4, rB5, rB6, rB7, rB8, rB9, rB10, rB11, rB12, rB13, rB14;
   register double rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0, rC6_0, rC0_1, rC1_1, rC2_1, rC3_1, rC4_1, rC5_1, rC6_1, rC0_2, rC1_2, rC2_2, rC3_2, rC4_2, rC5_2, rC6_2, rC0_3, rC1_3, rC2_3, rC3_3, rC4_3, rC5_3, rC6_3, rC0_4, rC1_4, rC2_4, rC3_4, rC4_4, rC5_4, rC6_4, rC0_5, rC1_5, rC2_5, rC3_5, rC4_5, rC5_5, rC6_5, rC0_6, rC1_6, rC2_6, rC3_6, rC4_6, rC5_6, rC6_6, rC0_7, rC1_7, rC2_7, rC3_7, rC4_7, rC5_7, rC6_7, rC0_8, rC1_8, rC2_8, rC3_8, rC4_8, rC5_8, rC6_8, rC0_9, rC1_9, rC2_9, rC3_9, rC4_9, rC5_9, rC6_9, rC0_10, rC1_10, rC2_10, rC3_10, rC4_10, rC5_10, rC6_10, rC0_11, rC1_11, rC2_11, rC3_11, rC4_11, rC5_11, rC6_11, rC0_12, rC1_12, rC2_12, rC3_12, rC4_12, rC5_12, rC6_12, rC0_13, rC1_13, rC2_13, rC3_13, rC4_13, rC5_13, rC6_13, rC0_14, rC1_14, rC2_14, rC3_14, rC4_14, rC5_14, rC6_14;
   if (pA0 != stM)
   {
      do /* N-loop */
      {
         do /* M-loop */
         {
            ATL_pfl1R(pfA);
            ATL_pfl1R(pfA+ATL_L1LS);
            ATL_pfl1R(pfA+3*ATL_L1LS);
            ATL_pfl1R(pfA+4*ATL_L1LS);
            ATL_pfl1R(pfA+5*ATL_L1LS);
            ATL_pfl1R(pfA+6*ATL_L1LS);
            ATL_pfl1R(pfA+7*ATL_L1LS);
            ATL_pfl1R(pfA+8*ATL_L1LS);
            ATL_pfl1R(pfA+9*ATL_L1LS);
            ATL_pfl1R(pfA+10*ATL_L1LS);
            ATL_pfl1R(pfA+11*ATL_L1LS);
            ATL_pfl1R(pfA+12*ATL_L1LS);
            pfA += incPFA;
            rA0 = beta;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC1_0 = pC0[1];
            rC1_0 *= rA0;
            rC2_0 = pC0[2];
            rC2_0 *= rA0;
            rC3_0 = pC0[3];
            rC3_0 *= rA0;
            rC4_0 = pC0[4];
            rC4_0 *= rA0;
            rC5_0 = pC0[5];
            rC5_0 *= rA0;
            rC6_0 = pC0[6];
            rC6_0 *= rA0;
            rC0_1 = *pC1;
            rC0_1 *= rA0;
            rC1_1 = pC1[1];
            rC1_1 *= rA0;
            rC2_1 = pC1[2];
            rC2_1 *= rA0;
            rC3_1 = pC1[3];
            rC3_1 *= rA0;
            rC4_1 = pC1[4];
            rC4_1 *= rA0;
            rC5_1 = pC1[5];
            rC5_1 *= rA0;
            rC6_1 = pC1[6];
            rC6_1 *= rA0;
            rC0_2 = *pC2;
            rC0_2 *= rA0;
            rC1_2 = pC2[1];
            rC1_2 *= rA0;
            rC2_2 = pC2[2];
            rC2_2 *= rA0;
            rC3_2 = pC2[3];
            rC3_2 *= rA0;
            rC4_2 = pC2[4];
            rC4_2 *= rA0;
            rC5_2 = pC2[5];
            rC5_2 *= rA0;
            rC6_2 = pC2[6];
            rC6_2 *= rA0;
            rC0_3 = *pC3;
            rC0_3 *= rA0;
            rC1_3 = pC3[1];
            rC1_3 *= rA0;
            rC2_3 = pC3[2];
            rC2_3 *= rA0;
            rC3_3 = pC3[3];
            rC3_3 *= rA0;
            rC4_3 = pC3[4];
            rC4_3 *= rA0;
            rC5_3 = pC3[5];
            rC5_3 *= rA0;
            rC6_3 = pC3[6];
            rC6_3 *= rA0;
            rC0_4 = *pC4;
            rC0_4 *= rA0;
            rC1_4 = pC4[1];
            rC1_4 *= rA0;
            rC2_4 = pC4[2];
            rC2_4 *= rA0;
            rC3_4 = pC4[3];
            rC3_4 *= rA0;
            rC4_4 = pC4[4];
            rC4_4 *= rA0;
            rC5_4 = pC4[5];
            rC5_4 *= rA0;
            rC6_4 = pC4[6];
            rC6_4 *= rA0;
            rC0_5 = *pC5;
            rC0_5 *= rA0;
            rC1_5 = pC5[1];
            rC1_5 *= rA0;
            rC2_5 = pC5[2];
            rC2_5 *= rA0;
            rC3_5 = pC5[3];
            rC3_5 *= rA0;
            rC4_5 = pC5[4];
            rC4_5 *= rA0;
            rC5_5 = pC5[5];
            rC5_5 *= rA0;
            rC6_5 = pC5[6];
            rC6_5 *= rA0;
            rC0_6 = *pC6;
            rC0_6 *= rA0;
            rC1_6 = pC6[1];
            rC1_6 *= rA0;
            rC2_6 = pC6[2];
            rC2_6 *= rA0;
            rC3_6 = pC6[3];
            rC3_6 *= rA0;
            rC4_6 = pC6[4];
            rC4_6 *= rA0;
            rC5_6 = pC6[5];
            rC5_6 *= rA0;
            rC6_6 = pC6[6];
            rC6_6 *= rA0;
            rC0_7 = *pC7;
            rC0_7 *= rA0;
            rC1_7 = pC7[1];
            rC1_7 *= rA0;
            rC2_7 = pC7[2];
            rC2_7 *= rA0;
            rC3_7 = pC7[3];
            rC3_7 *= rA0;
            rC4_7 = pC7[4];
            rC4_7 *= rA0;
            rC5_7 = pC7[5];
            rC5_7 *= rA0;
            rC6_7 = pC7[6];
            rC6_7 *= rA0;
            rC0_8 = *pC8;
            rC0_8 *= rA0;
            rC1_8 = pC8[1];
            rC1_8 *= rA0;
            rC2_8 = pC8[2];
            rC2_8 *= rA0;
            rC3_8 = pC8[3];
            rC3_8 *= rA0;
            rC4_8 = pC8[4];
            rC4_8 *= rA0;
            rC5_8 = pC8[5];
            rC5_8 *= rA0;
            rC6_8 = pC8[6];
            rC6_8 *= rA0;
            rC0_9 = *pC9;
            rC0_9 *= rA0;
            rC1_9 = pC9[1];
            rC1_9 *= rA0;
            rC2_9 = pC9[2];
            rC2_9 *= rA0;
            rC3_9 = pC9[3];
            rC3_9 *= rA0;
            rC4_9 = pC9[4];
            rC4_9 *= rA0;
            rC5_9 = pC9[5];
            rC5_9 *= rA0;
            rC6_9 = pC9[6];
            rC6_9 *= rA0;
            rC0_10 = *pC10;
            rC0_10 *= rA0;
            rC1_10 = pC10[1];
            rC1_10 *= rA0;
            rC2_10 = pC10[2];
            rC2_10 *= rA0;
            rC3_10 = pC10[3];
            rC3_10 *= rA0;
            rC4_10 = pC10[4];
            rC4_10 *= rA0;
            rC5_10 = pC10[5];
            rC5_10 *= rA0;
            rC6_10 = pC10[6];
            rC6_10 *= rA0;
            rC0_11 = *pC11;
            rC0_11 *= rA0;
            rC1_11 = pC11[1];
            rC1_11 *= rA0;
            rC2_11 = pC11[2];
            rC2_11 *= rA0;
            rC3_11 = pC11[3];
            rC3_11 *= rA0;
            rC4_11 = pC11[4];
            rC4_11 *= rA0;
            rC5_11 = pC11[5];
            rC5_11 *= rA0;
            rC6_11 = pC11[6];
            rC6_11 *= rA0;
            rC0_12 = *pC12;
            rC0_12 *= rA0;
            rC1_12 = pC12[1];
            rC1_12 *= rA0;
            rC2_12 = pC12[2];
            rC2_12 *= rA0;
            rC3_12 = pC12[3];
            rC3_12 *= rA0;
            rC4_12 = pC12[4];
            rC4_12 *= rA0;
            rC5_12 = pC12[5];
            rC5_12 *= rA0;
            rC6_12 = pC12[6];
            rC6_12 *= rA0;
            rC0_13 = *pC13;
            rC0_13 *= rA0;
            rC1_13 = pC13[1];
            rC1_13 *= rA0;
            rC2_13 = pC13[2];
            rC2_13 *= rA0;
            rC3_13 = pC13[3];
            rC3_13 *= rA0;
            rC4_13 = pC13[4];
            rC4_13 *= rA0;
            rC5_13 = pC13[5];
            rC5_13 *= rA0;
            rC6_13 = pC13[6];
            rC6_13 *= rA0;
            rC0_14 = *pC14;
            rC0_14 *= rA0;
            rC1_14 = pC14[1];
            rC1_14 *= rA0;
            rC2_14 = pC14[2];
            rC2_14 *= rA0;
            rC3_14 = pC14[3];
            rC3_14 *= rA0;
            rC4_14 = pC14[4];
            rC4_14 *= rA0;
            rC5_14 = pC14[5];
            rC5_14 *= rA0;
            rC6_14 = pC14[6];
            rC6_14 *= rA0;
            for (k=48; k; k--) /* easy loop to unroll */
            {
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[48];
               rA2 = pA0[96];
               rA3 = pA0[144];
               rA4 = pA0[192];
               rA5 = pA0[240];
               rC0_0 += rA0 * rB0;
               rA6 = pA0[288];
               rC1_0 += rA1 * rB0;
               rB1 = pB0[48];
               rC2_0 += rA2 * rB0;
               rB2 = pB0[96];
               rC3_0 += rA3 * rB0;
               rB3 = pB0[144];
               rC4_0 += rA4 * rB0;
               rB4 = pB0[192];
               rC5_0 += rA5 * rB0;
               rB5 = pB0[240];
               rC6_0 += rA6 * rB0;
               rB6 = pB0[288];
               rC0_1 += rA0 * rB1;
               rB7 = pB0[336];
               rC1_1 += rA1 * rB1;
               rB8 = pB0[384];
               rC2_1 += rA2 * rB1;
               rB9 = pB0[432];
               rC3_1 += rA3 * rB1;
               rB10 = pB0[480];
               rC4_1 += rA4 * rB1;
               rB11 = pB0[528];
               rC5_1 += rA5 * rB1;
               rB12 = pB0[576];
               rC6_1 += rA6 * rB1;
               rB13 = pB0[624];
               rC0_2 += rA0 * rB2;
               rB14 = pB0[672];
               rC1_2 += rA1 * rB2;
               rC2_2 += rA2 * rB2;
               rC3_2 += rA3 * rB2;
               rC4_2 += rA4 * rB2;
               rC5_2 += rA5 * rB2;
               rC6_2 += rA6 * rB2;
               rC0_3 += rA0 * rB3;
               rC1_3 += rA1 * rB3;
               rC2_3 += rA2 * rB3;
               rC3_3 += rA3 * rB3;
               rC4_3 += rA4 * rB3;
               rC5_3 += rA5 * rB3;
               rC6_3 += rA6 * rB3;
               rC0_4 += rA0 * rB4;
               rC1_4 += rA1 * rB4;
               rC2_4 += rA2 * rB4;
               rC3_4 += rA3 * rB4;
               rC4_4 += rA4 * rB4;
               rC5_4 += rA5 * rB4;
               rC6_4 += rA6 * rB4;
               rC0_5 += rA0 * rB5;
               rC1_5 += rA1 * rB5;
               rC2_5 += rA2 * rB5;
               rC3_5 += rA3 * rB5;
               rC4_5 += rA4 * rB5;
               rC5_5 += rA5 * rB5;
               rC6_5 += rA6 * rB5;
               rC0_6 += rA0 * rB6;
               rC1_6 += rA1 * rB6;
               rC2_6 += rA2 * rB6;
               rC3_6 += rA3 * rB6;
               rC4_6 += rA4 * rB6;
               rC5_6 += rA5 * rB6;
               rC6_6 += rA6 * rB6;
               rC0_7 += rA0 * rB7;
               rC1_7 += rA1 * rB7;
               rC2_7 += rA2 * rB7;
               rC3_7 += rA3 * rB7;
               rC4_7 += rA4 * rB7;
               rC5_7 += rA5 * rB7;
               rC6_7 += rA6 * rB7;
               rC0_8 += rA0 * rB8;
               rC1_8 += rA1 * rB8;
               rC2_8 += rA2 * rB8;
               rC3_8 += rA3 * rB8;
               rC4_8 += rA4 * rB8;
               rC5_8 += rA5 * rB8;
               rC6_8 += rA6 * rB8;
               rC0_9 += rA0 * rB9;
               rC1_9 += rA1 * rB9;
               rC2_9 += rA2 * rB9;
               rC3_9 += rA3 * rB9;
               rC4_9 += rA4 * rB9;
               rC5_9 += rA5 * rB9;
               rC6_9 += rA6 * rB9;
               rC0_10 += rA0 * rB10;
               rC1_10 += rA1 * rB10;
               rC2_10 += rA2 * rB10;
               rC3_10 += rA3 * rB10;
               rC4_10 += rA4 * rB10;
               rC5_10 += rA5 * rB10;
               rC6_10 += rA6 * rB10;
               rC0_11 += rA0 * rB11;
               rC1_11 += rA1 * rB11;
               rC2_11 += rA2 * rB11;
               rC3_11 += rA3 * rB11;
               rC4_11 += rA4 * rB11;
               rC5_11 += rA5 * rB11;
               rC6_11 += rA6 * rB11;
               rC0_12 += rA0 * rB12;
               rC1_12 += rA1 * rB12;
               rC2_12 += rA2 * rB12;
               rC3_12 += rA3 * rB12;
               rC4_12 += rA4 * rB12;
               rC5_12 += rA5 * rB12;
               rC6_12 += rA6 * rB12;
               rC0_13 += rA0 * rB13;
               rC1_13 += rA1 * rB13;
               rC2_13 += rA2 * rB13;
               rC3_13 += rA3 * rB13;
               rC4_13 += rA4 * rB13;
               rC5_13 += rA5 * rB13;
               rC6_13 += rA6 * rB13;
               rC0_14 += rA0 * rB14;
               rC1_14 += rA1 * rB14;
               rC2_14 += rA2 * rB14;
               rC3_14 += rA3 * rB14;
               rC4_14 += rA4 * rB14;
               rC5_14 += rA5 * rB14;
               rC6_14 += rA6 * rB14;
               pA0 += incAk;
               pB0 += incBk;
            }
            *pC0 = rC0_0;
            pC0[1] = rC1_0;
            pC0[2] = rC2_0;
            pC0[3] = rC3_0;
            pC0[4] = rC4_0;
            pC0[5] = rC5_0;
            pC0[6] = rC6_0;
            *pC1 = rC0_1;
            pC1[1] = rC1_1;
            pC1[2] = rC2_1;
            pC1[3] = rC3_1;
            pC1[4] = rC4_1;
            pC1[5] = rC5_1;
            pC1[6] = rC6_1;
            *pC2 = rC0_2;
            pC2[1] = rC1_2;
            pC2[2] = rC2_2;
            pC2[3] = rC3_2;
            pC2[4] = rC4_2;
            pC2[5] = rC5_2;
            pC2[6] = rC6_2;
            *pC3 = rC0_3;
            pC3[1] = rC1_3;
            pC3[2] = rC2_3;
            pC3[3] = rC3_3;
            pC3[4] = rC4_3;
            pC3[5] = rC5_3;
            pC3[6] = rC6_3;
            *pC4 = rC0_4;
            pC4[1] = rC1_4;
            pC4[2] = rC2_4;
            pC4[3] = rC3_4;
            pC4[4] = rC4_4;
            pC4[5] = rC5_4;
            pC4[6] = rC6_4;
            *pC5 = rC0_5;
            pC5[1] = rC1_5;
            pC5[2] = rC2_5;
            pC5[3] = rC3_5;
            pC5[4] = rC4_5;
            pC5[5] = rC5_5;
            pC5[6] = rC6_5;
            *pC6 = rC0_6;
            pC6[1] = rC1_6;
            pC6[2] = rC2_6;
            pC6[3] = rC3_6;
            pC6[4] = rC4_6;
            pC6[5] = rC5_6;
            pC6[6] = rC6_6;
            *pC7 = rC0_7;
            pC7[1] = rC1_7;
            pC7[2] = rC2_7;
            pC7[3] = rC3_7;
            pC7[4] = rC4_7;
            pC7[5] = rC5_7;
            pC7[6] = rC6_7;
            *pC8 = rC0_8;
            pC8[1] = rC1_8;
            pC8[2] = rC2_8;
            pC8[3] = rC3_8;
            pC8[4] = rC4_8;
            pC8[5] = rC5_8;
            pC8[6] = rC6_8;
            *pC9 = rC0_9;
            pC9[1] = rC1_9;
            pC9[2] = rC2_9;
            pC9[3] = rC3_9;
            pC9[4] = rC4_9;
            pC9[5] = rC5_9;
            pC9[6] = rC6_9;
            *pC10 = rC0_10;
            pC10[1] = rC1_10;
            pC10[2] = rC2_10;
            pC10[3] = rC3_10;
            pC10[4] = rC4_10;
            pC10[5] = rC5_10;
            pC10[6] = rC6_10;
            *pC11 = rC0_11;
            pC11[1] = rC1_11;
            pC11[2] = rC2_11;
            pC11[3] = rC3_11;
            pC11[4] = rC4_11;
            pC11[5] = rC5_11;
            pC11[6] = rC6_11;
            *pC12 = rC0_12;
            pC12[1] = rC1_12;
            pC12[2] = rC2_12;
            pC12[3] = rC3_12;
            pC12[4] = rC4_12;
            pC12[5] = rC5_12;
            pC12[6] = rC6_12;
            *pC13 = rC0_13;
            pC13[1] = rC1_13;
            pC13[2] = rC2_13;
            pC13[3] = rC3_13;
            pC13[4] = rC4_13;
            pC13[5] = rC5_13;
            pC13[6] = rC6_13;
            *pC14 = rC0_14;
            pC14[1] = rC1_14;
            pC14[2] = rC2_14;
            pC14[3] = rC3_14;
            pC14[4] = rC4_14;
            pC14[5] = rC5_14;
            pC14[6] = rC6_14;
            pC0 += incCm;
            pC1 += incCm;
            pC2 += incCm;
            pC3 += incCm;
            pC4 += incCm;
            pC5 += incCm;
            pC6 += incCm;
            pC7 += incCm;
            pC8 += incCm;
            pC9 += incCm;
            pC10 += incCm;
            pC11 += incCm;
            pC12 += incCm;
            pC13 += incCm;
            pC14 += incCm;
            pA0 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pC1 += incCn;
         pC2 += incCn;
         pC3 += incCn;
         pC4 += incCn;
         pC5 += incCn;
         pC6 += incCn;
         pC7 += incCn;
         pC8 += incCn;
         pC9 += incCn;
         pC10 += incCn;
         pC11 += incCn;
         pC12 += incCn;
         pC13 += incCn;
         pC14 += incCn;
         pA0 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   ATL_dJIK0x3x48TN7x3x1_a1_bX(M, 3, 48, alpha, ca, lda, cb + 2160, ldb, beta, cc + (45*(ldc)), ldc);
   if (k=M-Mb)
      ATL_dJIK0x45x48TN1x15x1_a1_bX(k, 45, 48, alpha, ca + (((Mb) << 5)+((Mb) << 4)), lda, cb, ldb, beta, cc + (Mb), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
